//Shell Debris
datablock DebrisData(scoutSniperShellDebris)
{
	shapeFile = "Add-Ons/Weapon_Gun/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//Muzzle Flash
datablock ParticleData(scoutSniperFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(scoutSniperFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "scoutSniperFlashParticle";

   uiName = "Scout Sniper Flash";
};

datablock ParticleData(scoutSniperSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(scoutSniperSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "scoutSniperSmokeParticle";

   uiName = "Scout Sniper Smoke";
};


datablock ParticleData(scoutSniperExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(scoutSniperExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "scoutSniperExplosionParticle";

   useEmitterColors = true;
   uiName = "Scout Sniper Hit Dust";
};


datablock ParticleData(scoutSniperExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(scoutSniperExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "scoutSniperExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Scout Sniper Hit Flash";
};

datablock ExplosionData(scoutSniperExplosion)
{
   //explosionShape = ""; //Usually for explosives
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = scoutSniperExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = scoutSniperExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

//bullet trail effects
datablock ParticleData(scoutSniperBulletTrailParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 25;
   textureName          = "base/data/particles/thinRing";
   spinSpeed      = 10.0;
   spinRandomMin     = -500.0;
   spinRandomMax     = 500.0;
   colors[0]     = "0.9 0.9 0.9 0.2";
   colors[1]     = "0.6 0.6 0.6 0.0";
   sizes[0]      = 0.15;
   sizes[1]      = 0.25;

   useInvAlpha = false;
};
datablock ParticleEmitterData(scoutSniperBulletTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "scoutSniperBulletTrailParticle";
};

AddDamageType("scoutSniper",   '<bitmap:add-ons/Weapon_scoutSniper/CI_scoutSniper> %1',    '%2 <bitmap:add-ons/Weapon_scoutSniper/CI_scoutSniper> %1',0.2,1);
AddDamageType("scoutSniperHeadshot",   '<bitmap:add-ons/Weapon_scoutSniper/CI_scoutSniper><bitmap:add-ons/Weapon_scoutSniper/CI_headshot> %1',    '%2 <bitmap:add-ons/Weapon_scoutSniper/CI_scoutSniper><bitmap:add-ons/Weapon_scoutSniper/CI_headshot> %1',0.2,1);
datablock ProjectileData(scoutSniperTracerProjectile)
{
   projectileShapeName = ""; //Add-Ons/Weapon_Gun/bullet.dts
   directDamage        = 0;			//When projectile hits a player
   directDamageType    = $DamageType::scoutSniper; //Don't mess with this
   radiusDamageType    = $DamageType::scoutSniper; //Don't mess with this

   brickExplosionRadius = 0;			
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;			//Amount of force applied to fake-killed bricks
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 100;
   particleEmitter     = "scoutSniperBulletTrailEmitter";

   // sound               = scoutWhizzSound;

   muzzleVelocity      = 200;		//How fast the bullet travels.
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 1000;		//Lifetime of projectile
   fadeDelay           = 500;		//Keep this reletively 1000ms or 500ms below "lifetime"
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.5;		//Gravity effect applied to bullet. Do not make it too high

   hasLight    = false;		//Self explanitory 
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   // uiName = "Scout Sniper Bullet";	//Name of projectile in events for spawning
};

//////////
// item //
//////////
datablock ItemData(scoutSniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./models/scout.dts";		//If you use two-handed weapons, this is what would NOT have two hands
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Scout Sniper";		//Name when you spawn on a brick
	iconName = "./icon_scoutSniper";
	doColorShift = false;
	// colorShiftColor = "0.4 0.2 0 1.000";

	 // Dynamic properties defined by the scripts
	image = scoutSniperImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(scoutSniperImage)
{
   // Basic Item properties
   shapeFile = "./models/scout.dts";		//If you use two-handed weapons, this is what would have two hands
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = scoutSniperItem;
   ammo = " ";
   projectile = scoutSniperTracerProjectile;
   projectileType = Projectile;

	casing = scoutSniperShellDebris;		//Don't mess with these too much
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = false;
   // colorShiftColor = scoutSniperItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   raycastWeaponRange = 1000; //varies
   raycastWeaponTargets = $TypeMasks::All ^ $TypeMasks::alwaysBrickObjectType;
   raycastExplosionProjectile = gunProjectile;
   raycastExplosionBrickSound = scoutSniperHitSound;
   raycastExplosionPlayerSound = scoutSniperHitSound;
   raycastDirectDamage = 74;
   raycastDirectDamageType = $DamageType::scoutSniper;
   raycastSpreadAmt = 0.0001; //varies
   raycastSpreadCount = 1;
   raycastTracerProjectile = scoutSniperTracerProjectile;
   raycastFromMuzzle = true;


   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.15;
   stateTransitionOnTimeout[0]       = "Ready";
   stateSound[0]              = weaponSwitchSound;

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";
   stateAllowImageChange[1]         = true;
   stateSequence[1]  = "Ready";

   stateName[2]                    = "Fire";
   stateTransitionOnTimeout[2]     = "Smoke";
   stateTimeoutValue[2]            = 0.12;
   stateFire[2]                    = true;
   stateAllowImageChange[2]        = false;
   stateSequence[2]                = "Fire";
   stateScript[2]                  = "onFire";
   stateWaitForTimeout[2]        = true;
   stateEmitter[2]               = scoutSniperFlashEmitter;
   stateEmitterTime[2]           = 0.05;
   stateEmitterNode[2]           = "muzzleNode";
   stateSound[2]              = scoutSniperFireSound;
   stateEjectShell[2]       = true;

   stateName[3] = "Smoke";
   stateEmitter[3]               = scoutSniperSmokeEmitter;
   stateEmitterTime[3]           = 0.9;
   stateEmitterNode[3]           = "muzzleNode";
   stateTimeoutValue[3]            = 2.3;
   stateTransitionOnTimeout[3]     = "Reload";

   stateName[4]         = "Reload";
   stateSequence[4]                = "Reload";
   stateTransitionOnTriggerUp[4]     = "Ready";
   stateSequence[4]  = "Ready";
};

function scoutSniperImage::onFire(%this,%obj,%slot)
{
   if($Sim::Time - %this.lastShot < 2.3)
   {
      return;
   }

   %this.lastShot = $Sim::Time;

   %obj.playThread(2, standJump);

   if(vectorLen(%obj.getVelocity()) > 0.1)
   {
      %this.raycastSpreadAmt = 0.0003;
   }
   else
   {
      %this.raycastSpreadAmt = 0.0001;
   }

   parent::onFire(%this, %obj, %slot);
}

function scoutSniperImage::onRaycastDamage(%this, %obj, %slot, %col, %pos, %normal, %shotVec, %crit)
{
   %damage = %this.raycastDirectDamage;
   %headshot = matchBodyArea( getHitbox( %obj, %col, %pos ), $headTest );
   %legshot = matchBodyArea( getHitbox( %obj, %col, %pos ), $legTest );

   if ( %headshot )
   {
     %damageType = $DamageType::scoutSniperHeadshot;
     %col.playThread( "headUp" );
     %damage *= 3;
   }

   if ( %legshot )
   {
     %damage /= 1.5;
     %col.setVelocity( "0 0" SPC getWord( %col.getVelocity(), 2 ) );
   }

   %col.damage( %obj, %pos, %damage, %this.raycastDirectDamageType );

   if ( %headshot && %col.getState() $= "Dead" )
   {
     %col.setNodeColor( "headSkin", "1 0 0 1" );
   }
}